{
 "cells": [
  {
   "cell_type": "markdown",
   "id": "192495d5",
   "metadata": {},
   "source": [
    "# Analyse av enzymkinetikkdata"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "33eaea85",
   "metadata": {},
   "source": [
    "I forrige laboratorieoppgave gjorde dere kinetikkmålinger på enzymet alkalisk fosfatase, som er vist nedenfor."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "id": "4f15b972",
   "metadata": {
    "tags": [
     "hide-input"
    ]
   },
   "outputs": [
    {
     "data": {
      "application/3dmoljs_load.v0": "<div id=\"3dmolviewer_1709298774445472\"  style=\"position: relative; width: 640px; height: 480px\">\n        <p id=\"3dmolwarning_1709298774445472\" style=\"background-color:#ffcccc;color:black\">You appear to be running in JupyterLab (or JavaScript failed to load for some other reason).  You need to install the 3dmol extension: <br>\n        <tt>jupyter labextension install jupyterlab_3dmol</tt></p>\n        </div>\n<script>\n\nvar loadScriptAsync = function(uri){\n  return new Promise((resolve, reject) => {\n    //this is to ignore the existence of requirejs amd\n    var savedexports, savedmodule;\n    if (typeof exports !== 'undefined') savedexports = exports;\n    else exports = {}\n    if (typeof module !== 'undefined') savedmodule = module;\n    else module = {}\n\n    var tag = document.createElement('script');\n    tag.src = uri;\n    tag.async = true;\n    tag.onload = () => {\n        exports = savedexports;\n        module = savedmodule;\n        resolve();\n    };\n  var firstScriptTag = document.getElementsByTagName('script')[0];\n  firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);\n});\n};\n\nif(typeof $3Dmolpromise === 'undefined') {\n$3Dmolpromise = null;\n  $3Dmolpromise = loadScriptAsync('https://cdnjs.cloudflare.com/ajax/libs/3Dmol/2.0.1/3Dmol-min.js');\n}\n\nvar viewer_1709298774445472 = null;\nvar warn = document.getElementById(\"3dmolwarning_1709298774445472\");\nif(warn) {\n    warn.parentNode.removeChild(warn);\n}\n$3Dmolpromise.then(function() {\nviewer_1709298774445472 = $3Dmol.createViewer(document.getElementById(\"3dmolviewer_1709298774445472\"),{backgroundColor:\"white\"});\n$3Dmol.download(\"pdb:1ANJ\", viewer_1709298774445472, {}, function() {\nviewer_1709298774445472.zoomTo();\n\tviewer_1709298774445472.setStyle({\"cartoon\": {\"color\": \"spectrum\"}});\nviewer_1709298774445472.render();\n})\n});\n</script>",
      "text/html": [
       "<div id=\"3dmolviewer_1709298774445472\"  style=\"position: relative; width: 640px; height: 480px\">\n",
       "        <p id=\"3dmolwarning_1709298774445472\" style=\"background-color:#ffcccc;color:black\">You appear to be running in JupyterLab (or JavaScript failed to load for some other reason).  You need to install the 3dmol extension: <br>\n",
       "        <tt>jupyter labextension install jupyterlab_3dmol</tt></p>\n",
       "        </div>\n",
       "<script>\n",
       "\n",
       "var loadScriptAsync = function(uri){\n",
       "  return new Promise((resolve, reject) => {\n",
       "    //this is to ignore the existence of requirejs amd\n",
       "    var savedexports, savedmodule;\n",
       "    if (typeof exports !== 'undefined') savedexports = exports;\n",
       "    else exports = {}\n",
       "    if (typeof module !== 'undefined') savedmodule = module;\n",
       "    else module = {}\n",
       "\n",
       "    var tag = document.createElement('script');\n",
       "    tag.src = uri;\n",
       "    tag.async = true;\n",
       "    tag.onload = () => {\n",
       "        exports = savedexports;\n",
       "        module = savedmodule;\n",
       "        resolve();\n",
       "    };\n",
       "  var firstScriptTag = document.getElementsByTagName('script')[0];\n",
       "  firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);\n",
       "});\n",
       "};\n",
       "\n",
       "if(typeof $3Dmolpromise === 'undefined') {\n",
       "$3Dmolpromise = null;\n",
       "  $3Dmolpromise = loadScriptAsync('https://cdnjs.cloudflare.com/ajax/libs/3Dmol/2.0.1/3Dmol-min.js');\n",
       "}\n",
       "\n",
       "var viewer_1709298774445472 = null;\n",
       "var warn = document.getElementById(\"3dmolwarning_1709298774445472\");\n",
       "if(warn) {\n",
       "    warn.parentNode.removeChild(warn);\n",
       "}\n",
       "$3Dmolpromise.then(function() {\n",
       "viewer_1709298774445472 = $3Dmol.createViewer(document.getElementById(\"3dmolviewer_1709298774445472\"),{backgroundColor:\"white\"});\n",
       "$3Dmol.download(\"pdb:1ANJ\", viewer_1709298774445472, {}, function() {\n",
       "viewer_1709298774445472.zoomTo();\n",
       "\tviewer_1709298774445472.setStyle({\"cartoon\": {\"color\": \"spectrum\"}});\n",
       "viewer_1709298774445472.render();\n",
       "})\n",
       "});\n",
       "</script>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "import py3Dmol\n",
    "\n",
    "d = py3Dmol.view(query=\"pdb:1ANJ\")\n",
    "d.setStyle({\"cartoon\": {\"color\": \"spectrum\"}})\n",
    "d.show()"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "6ae6f917",
   "metadata": {},
   "source": [
    "Du skal nå lære hvordan du kan visualisere og analysere enzymkinetikkdata med Python. Du kan bruke en valgfri editor til å lage programmene som gjør analysen av data fra enzymkinetikklaben, for eksempel Jupyter Notebook. Figurene og resultatene skal brukes i labrapporten. Hvis du står fast, kan du spørre generativ kunstig intelligens (gpt.uio.no) om hjelp. Da kan det være lurt å spesifisere hvilken del av koden du trenger hjelp til ved å lime inn koden og formatet på datafilene dine. Bruk GPT4o som modell. Hvis dette heller ikke hjelper, kan du spørre labansvarlige om hjelp (veiledningstime uka etter laben)."
   ]
  },
  {
   "cell_type": "markdown",
   "id": "e7e83de4",
   "metadata": {},
   "source": [
    "## Steg 1: Finne initialhastighetene\n",
    "\n",
    "Før vi kan begynne å analysere en Michaelis-Menten-modell for dataene våre, må vi finne initialhastigheten til reaksjonen som en funksjon av substratkonsentrasjonen fra dataene våre av absorbansøkning over tid.\n",
    "\n",
    "### Importere data\n",
    "Du har lagret data fra enzymkinetikklaben som separate csv-filer. Fila inneholder to kolonner: tid og absorbans. Vi skal bruke disse dataene til å finne initialhastigheten til reaksjonen som en funksjon av substratkonsentrasjonen.\n",
    "\n",
    "La oss se på hvordan vi kan lese av fila. Det finnes mange måter å importere filer på i Python. Du kan velge den metoden du er mest komfortabel med. Det enkleste metoden er å bruke _read\\_csv_ fra pandas-biblioteket:\n",
    "\n",
    "```{code-block} Python\n",
    "import pandas as pd\n",
    "\n",
    "data = pd.read_csv(\"Absorbans_tid.csv\") # Leser fila\n",
    "\n",
    "tid = data[\"tid\"]\n",
    "absorbans = data[\"absorbans\"]\n",
    "```\n",
    "\n",
    "Fila du skal lese av, må ligge i samme mappe som programmet som skal analysere og lese fila. Eventuelt kan vi angi filbanen, f.eks. \"datafiler/Absorbans_tid.csv\". Vi kan også lese direkte fra internett. Da erstatter du filnavnet med en lenke.\n",
    "\n",
    "Du skal lese fem filer, en for hver substratkonsentrasjon. Du kan bruke en løkke for å lese alle filene. \n",
    "\n",
    "````{admonition} Oppgave\n",
    ":class: tip\n",
    "Lag et program som leser alle filene og lagrer dataene i lister. Du kan ta utgangspunkt i programmet nedenfor. Prøv selv før du kikker på løsningsforslaget!\n",
    "\n",
    "```{code-block} Python  \n",
    "import pandas as pd\n",
    "import matplotlib.pyplot as plt\n",
    "\n",
    "# Liste over filnavn\n",
    "data_files = [f\"data{i}.csv\" for i in range(1, 6)] # Denne lista kan også lages manuelt ([\"data1.csv\", \"data2.csv\", ...])\n",
    "\n",
    "# Les og plott data fra alle filer med en løkke som går over alle filnavnene\n",
    "# Fyll inn koden her\n",
    "\n",
    "plt.xlabel(\"Tid (min)\")\n",
    "plt.ylabel(\"Absorbans\")\n",
    "plt.legend()\n",
    "plt.grid()\n",
    "plt.show()\n",
    "```\n",
    "````\n",
    "\n",
    "````{admonition} Løsningsforslag\n",
    ":class: tip, dropdown\n",
    "```{code-block} Python\n",
    "import pandas as pd\n",
    "import matplotlib.pyplot as plt\n",
    "\n",
    "# Liste over filnavn\n",
    "data_files = [f\"data{i}.csv\" for i in range(1, 6)] # Denne lista kan også lages manuelt ([\"data1.csv\", \"data2.csv\", ...])\n",
    "\n",
    "# Les og plott data fra alle filer\n",
    "for file in data_files:\n",
    "    df = pd.read_csv(file, delimiter=\";\")\n",
    "    t = df[\"tid_min\"]\n",
    "    A = df[\"abs\"]\n",
    "    plt.scatter(t, A, label=file)\n",
    "\n",
    "plt.xlabel(\"Tid (min)\")\n",
    "plt.ylabel(\"Absorbans\")\n",
    "plt.title(\"Absorbansmålinger uten hemmer\")\n",
    "plt.legend()\n",
    "plt.grid()\n",
    "plt.show()\n",
    "```\n",
    "````"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "d7dcb26b",
   "metadata": {},
   "source": [
    "### Lineærtilpasning av dataene\n",
    "\n",
    "Lineær regresjon betyr å finne et polynom av første grad (en førstegradsfunksjon) som gir minst mulig gjennomsnittlig varians til et sett med datapunkter. Metodene vi skal bruke, benytter minste kvadraters metode for å estimere en slik funksjon. En funksjon som er ganske enkel å bruke til dette, er _polyfit_ fra numpy-biblioteket. Du kjenner kanskje til og med denne funksjonen fra før (f.eks. fra IN-KJM1900). Denne funksjonen utfører polynomregresjon med en vilkårlig grad av polynomet. \n",
    "\n",
    "Det polyfit-funksjonen derimot ikke kan estimere direkte, er andre typer regresjonsmodeller enn lineære, slik som eksponentialfunksjoner, logaritmefunksjoner eller logistiske funksjoner. Vi skal gjøre en logistisk regresjon seinere, og derfor benytter vi heller en annen funksjon som heter _curve\\_fit_ fra scipy-biblioteket også når vi skal gjøre lineær regresjon i denne laben. Denne funksjonen returnerer både koeffisientene i regresjonslinja og et mål på hvor godt modellen passer dataene (såkalt kovarians). Det er koeffisientene _a_ og _b_ i uttrykket $f(x) = ax + b$ som estimeres når vi gjør en linær regresjon.\n",
    "\n",
    "I _curve\\_fit_ må vi definere en funksjonsmodell på formen $f(x, a, b, c, ...)$ som brukes som utgangspunkt for regresjonen. Her skal vi definere en funksjon $f(x, a, b) = ax + b$.\n",
    "\n",
    "Nå skal du gjøre en oppgavene/nivåene nedenfor. Velg kun én av nivåene. Dersom du mener du behersker enkel plotting og regresjon med curve\\_fit, velger du nivå 1. Dersom du er usikker på hvordan dette gjøres, kan du velge nivå 2. Prøv gjerne på nivå 1 før du prøver på nivå 2 - da lærer du enda mer! Du kan laste ned filene fra Canvas og bruke dem i en valgfri editor, som Jupyter Notebook eller Spyder.\n",
    "\n",
    "````{admonition} Oppgave\n",
    ":class: tip\n",
    "1. Se på programmmet nedenfor og forklar hva det gjør, trinn for trinn.\n",
    "2. Hva beskriver variabelen _koeff_?\n",
    "3. Forklar hvordan vi kan plotte originaldataene sammen med regresjonslinja?\n",
    "\n",
    "\n",
    "```{code-block} Python\n",
    "import pandas as pd\n",
    "import numpy as np\n",
    "import scipy.optimize as opt\n",
    "\n",
    "data = pd.read_csv(\"Absorbans_tid.csv\")\n",
    "\n",
    "tid = data[\"tid\"]\n",
    "absorbans = data[\"absorbans\"]\n",
    "\n",
    "# Definerer formen på modellen vi ønsker\n",
    "def modell(x, a, b):\n",
    "    return a*x + b\n",
    "\n",
    "koeff, covar = opt.curve_fit(modell, tid, absorbans)\n",
    "# Finner a og b her\n",
    "a = koeff[0]\n",
    "b = koeff[1]\n",
    "\n",
    "# Beregner funksjonsverdier til den lineære tilpasningen\n",
    "x = np.linspace(0,35,100) # Nye x-verdier å plotte med\n",
    "y = a*x + b               # Regresjonsmodellens y-verdier\n",
    "```\n",
    "````"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "c740b813",
   "metadata": {},
   "source": [
    "### Håndtering av flere datafiler\n",
    "Vi skal nå kombinere de to stegene ovenfor for å analysere alle dataene våre. Vi skal gjøre en lineær regresjon for hver fil og plotte regresjonslinjene sammen med originaldataene.\n",
    "\n",
    "```{admonition} Oppgave\n",
    ":class: tip\n",
    "Prøv å kombinere løkka som leser alle dataene med regresjonen av dataene. Du kan ta utgangspunkt i programmene ovenfor. Prøv selv før du kikker på løsningsforslaget!\n",
    "```\n",
    "\n",
    "````{admonition} Løsningsforslag\n",
    ":class: tip, dropdown\n",
    "\n",
    "```{code-block} Python\n",
    "import pandas as pd\n",
    "import numpy as np\n",
    "import scipy.optimize as opt\n",
    "import matplotlib.pyplot as plt\n",
    "\n",
    "# Liste over filnavn\n",
    "data_files = [f\"data{i}.csv\" for i in range(1, 6)] # Denne lista kan også lages manuelt ([\"data1.csv\", \"data2.csv\", ...])\n",
    "S = [0.257, 0.0634, 0.0343, 0.0171, 0.0114] # Konsentrasjoner (mg/mL). \n",
    "# Definerer formen på modellen vi ønsker\n",
    "def modell(x, a, b):\n",
    "    return a*x + b\n",
    "\n",
    "V0 = [] # Initialhastigheter\n",
    "\n",
    "# Les og plott data fra alle filer\n",
    "for file, kons in zip(data_files, konsentrasjoner): # kan også bruke for fole in data_files: dersom du ikke har med navnelapper på konsentrasjonene\n",
    "    df = pd.read_csv(file, delimiter=\";\")\n",
    "    t = df[\"tid_min\"]\n",
    "    A = df[\"abs\"]\n",
    "\n",
    "    koeff, covar = opt.curve_fit(modell, t, A)\n",
    "    a = koeff[0]\n",
    "    b = koeff[1]\n",
    "    \n",
    "    # Beregner funksjonsverdier til den lineære tilpasningen\n",
    "    x = np.linspace(0,15) # Nye x-verdier å plotte med\n",
    "    y = a*x + b               # Regresjonsmodellens y-verdier\n",
    "\n",
    "    v0.append(a) # Legger til initialhastigheten i lista\n",
    "    plt.scatter(t, A, label=str(kons) + \" mg/mL\")\n",
    "    plt.plot(x, y, label=f\"y = {a:.2f}x + {b:.2f}\")\n",
    "\n",
    "plt.xlabel(\"Tid (min)\")\n",
    "plt.ylabel(\"Absorbans\")\n",
    "plt.title(\"Absorbansmålinger av alkalisk fosfatase med PNPP\")\n",
    "plt.legend()\n",
    "plt.grid()\n",
    "plt.show()\n",
    "```\n",
    "````\n",
    "\n",
    "````{admonition} Oppgave\n",
    ":class: tip\n",
    "Lagre grafen som et høyoppløselig bilde, og lagre dataene dine  i en ny csv-fil. Dette kan du gjøre ved å legge til følgende kode nederst i programmet ditt (men før plt.show()):\n",
    "```{code-block} Python\n",
    "plt.savefig(\"initialhastigheter.tiff\") # kan også angi oppløsning med f.eks. dpi=500 (500 piksler per tomme)\n",
    "\n",
    "# Lagrer dataene i en dataframe og skriver dem til en csv-fil\n",
    "d = {\"Hastighet\": V0, \"Substratkonsentrasjon\": S}\n",
    "df = pd.DataFrame(d)\n",
    "df.to_csv(\"Reaksjonshastigheter.csv\", index = False)\n",
    "```\n",
    "````"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "23aa550c",
   "metadata": {},
   "source": [
    "## Steg 2: Finne vmaks og Km\n",
    "\n",
    "### Michaelis-Menten-modellen\n",
    "Vi skal nå plotte og analysere resultatene fra første analyse. Vi skal altså lage et Michaelis-Menten-plott og tilpasse Michaelis-Menten-likningen til verdiene vi fant for initialhastighetene. Vi har lagret substratkonsentrasjonene og de tilhørende initialhastighetene i en .csv-fil (reaksjonshastigheter.csv), og vi skal bruke denne fila videre.\n",
    "\n",
    "```{admonition} Oppgave\n",
    ":class: tip\n",
    "1. Les av fila som du lagde i forrige program, og skriv ut initialhastighetene og tilhørende substratkonsentrasjoner for å se at du har lest inn fila korrekt.\n",
    "2. Plott dataene (gjerne med scatter, slik at du får punkter istedenfor linjer) slik at du får et Michaelis-Menten-plott (husk hvilken form grafen skal ha!). Husk aksetitler med korrekte enheter.\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "209ae84e",
   "metadata": {},
   "source": [
    "Nå skal vi lage en modellkurve som er basert på Michaelis-Menten-likningen. Denne kan vi definere som en Python-funksjon, slik (på samme måte som du definerte den lineære funksjonen i del 1):"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "id": "ee022cad",
   "metadata": {},
   "outputs": [],
   "source": [
    "def michaelis_menten(x, Vmax, Km):\n",
    "    return Vmax*x/(Km + x)"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "0bd92b92",
   "metadata": {},
   "source": [
    "```{admonition} Oppgave\n",
    ":class: tip\n",
    "1. Bruk funksjonen ovenfor og gjør en regresjon av initialhastighetene med _curve\\_fit_ på samme måte som med den lineære funksjonen (men nå skal du bruke michaelis-menten-funksjonen som regresjonsmodell isteden).\n",
    "2. Plott regresjonskurven i samme koordinatsystem som dataene dine.\n",
    "3. Modifiser programmet slik at Km får enheten mol/L (M) og Vmax får enheten mol/L/min (M/min) (dette er ikke gjort i løsningsforslaget, så det må du gjøre selv). Ekstinksjonskoeffisienten, ε, til produktet er 18 000 M/cm. Lysveien, l (lengden av kyvetten), er 1 cm.\n",
    "```\n",
    "\n",
    "````{admonition} Løsningsforslag\n",
    ":class: tip, dropdown\n",
    "```{code-block} Python\n",
    "import pandas as pd\n",
    "import numpy as np\n",
    "\n",
    "data = pd.read_csv(\"reaksjonshastigheter.csv\")\n",
    "\n",
    "S = data[\"Substratkonsentrasjon\"]\n",
    "V0 = data[\"Initialhastighet\"]\n",
    "\n",
    "def michaelis_menten(S, Vmax, Km):\n",
    "    return Vmax*S/(Km + S)\n",
    "\n",
    "koeff, covar = opt.curve_fit(michaelis_menten, S, V0)\n",
    "Vmax = koeff[0]\n",
    "Km = koeff[1]\n",
    "\n",
    "# Beregner funksjonsverdier til Michaelis-Menten-tilpasningen\n",
    "S = np.linspace(0,0.3,100) # Nye x-verdier å plotte med\n",
    "V = michaelis_menten(S, Vmax, Km) # Regresjonsmodellens y-verdier\n",
    "\n",
    "plt.scatter(S, V0, label=\"Data\")\n",
    "plt.plot(S, V, label=f\"Michaelis-Menten: Vmax = {Vmax:.2f}, Km = {Km:.2f}\")\n",
    "\n",
    "plt.xlabel(\"Substratkonsentrasjon (mg/mL)\")\n",
    "plt.ylabel(\"Initialhastighet (mg/mL/min)\")\n",
    "plt.title(\"Michaelis-Menten-plot\")\n",
    "plt.legend()\n",
    "plt.grid()\n",
    "plt.show()\n",
    "```\n",
    "````"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "612cb46c",
   "metadata": {},
   "source": [
    "### pH-optimum\n",
    "I dette forsøket har du målt absorbansen kun ved start og slutt. Det betyr at du her ikke skal gjøre en kurvetilpassing for å beregne hastigheten, men istedenfor bruke differansen i absorbans og dividere med tiden. Husk å korrigere de siste avlesningsverdiene for fortynningen med Tris (hint: fortynningsfaktor). \n",
    "\n",
    "```{admonition} Oppgave\n",
    ":class: tip\n",
    "Lag et program som plotter en grafisk fremstilling av reaksjonshastigheten som funksjon av pH. Du kan gjøre alle beregninger i programmet. Et hint er å lagre alle dataene dine i arrayer. Dette gjør det enkelt å behandle dataene matematisk, for eksempel for å ta hensuyn til fortynningen med Tris.\n",
    "```"
   ]
  },
  {
   "cell_type": "markdown",
   "id": "7bcdca9e",
   "metadata": {},
   "source": [
    "### Enzymhemming\n",
    "For å avgjøre om en hemmer er ikke-konkurrerende eller konkurrerende, kan vi plotte en modell for initalhastigheter med og uten hemmer i samme koordinatsystem. Du kan bruke samme framgangsmåte som i del 1, der du lagde en løkke som gikk igjennom flere filer med data, analyserte og plottet dataene. Vi skal bruke et Michaelis-Menten-plott for å sammenlikne resultatene for et enzym med og uten hemmer. Dersom du vil, kan du også prøve å lage et Lineweaver-Burk-plott.\n",
    "\n",
    "```{admonition} Oppgave\n",
    ":class: tip\n",
    "1. Bruk programmet du lagde i del 1 for å lage en fil med initialhastigheter med hemmer.\n",
    "2. Bruk programmet du lagde i del 2 for å konstruere det samme MM-plottet du lagde ovenfor, og legg til et MM-plott for dataene med hemmer i samme koordinatsystem.\n",
    "3. Kjør programmet og forklar formen på grafen. Hva slags type hemmer har vi å gjøre med her?\n",
    "```\n",
    "\n",
    "````{admonition} Løsningsforslag\n",
    ":class: tip, dropdown\n",
    "\n",
    "Dette er et løsningsforslag på oppgave 2. I oppgave 1 kan du mer eller mindre bruke det samme programmet som i del 1 - bare juster for filnavn og konsentrasjoner.\n",
    "```{code-block} Python\n",
    "import pandas as pd\n",
    "import numpy as np\n",
    "\n",
    "data = pd.read_csv(\"reaksjonshastigheter.csv\")\n",
    "\n",
    "S = data[\"Substratkonsentrasjon\"]\n",
    "V0 = data[\"Initialhastighet\"]\n",
    "\n",
    "def michaelis_menten(S, Vmax, Km):\n",
    "    return Vmax*S/(Km + S)\n",
    "\n",
    "koeff, covar = opt.curve_fit(michaelis_menten, S, V0)\n",
    "Vmax = koeff[0]\n",
    "Km = koeff[1]\n",
    "\n",
    "# Beregner funksjonsverdier til Michaelis-Menten-tilpasningen\n",
    "S = np.linspace(0,0.3,100) # Nye x-verdier å plotte med\n",
    "V = michaelis_menten(S, Vmax, Km) # Regresjonsmodellens y-verdier\n",
    "\n",
    "plt.scatter(S, V0, label=\"Data\")\n",
    "plt.plot(S, V, label=f\"Michaelis-Menten: Vmax = {Vmax:.2f}, Km = {Km:.2f}\")\n",
    "\n",
    "plt.xlabel(\"Substratkonsentrasjon (mg/mL)\")\n",
    "plt.ylabel(\"Initialhastighet (mg/mL/min)\")\n",
    "plt.title(\"Michaelis-Menten-plot\")\n",
    "plt.legend()\n",
    "plt.grid()\n",
    "\n",
    "# Legg til data med hemmer\n",
    "data_hemmer = pd.read_csv(\"reaksjonshastigheter_hemmer.csv\")\n",
    "\n",
    "S_hemmer = data_hemmer[\"Substratkonsentrasjon\"]\n",
    "V0_hemmer = data_hemmer[\"Initialhastighet\"]\n",
    "\n",
    "koeff_hemmer, covar_hemmer = opt.curve_fit(michaelis_menten, S_hemmer, V0_hemmer)\n",
    "Vmax_hemmer = koeff_hemmer[0]\n",
    "Km_hemmer = koeff_hemmer[1]\n",
    "\n",
    "V_hemmer = michaelis_menten(S, Vmax_hemmer, Km_hemmer) # Regresjonsmodellens y-verdier\n",
    "\n",
    "plt.scatter(S_hemmer, V0_hemmer, label=\"Data med hemmer\")\n",
    "plt.plot(S, V_hemmer, label=f\"Michaelis-Menten med hemmer: Vmax = {Vmax_hemmer:.2f}, Km = {Km_hemmer:.2f}\")\n",
    "\n",
    "plt.show()\n",
    "```\n",
    "````\n",
    "\n",
    "## Rapport\n",
    "\n",
    "```{admonition} Rapport\n",
    ":class: tip\n",
    "Lagre alle figurer du trenger med _savefig_-kommandoen og print ut eller lagre alle koeffisientene du har funnet. Bruk gjerne en tabell for å presentere resultatene. Skriv labrapporten din basert på resultatene du har funnet. Du kan bruke malen for labrapporten som ligger på Canvas. Husk å sette riktige enheter på alle verdier og grafer! Her er en veiledning for skriving av rapporten:\n",
    "\n",
    "- Forsøk 1: Fremstill initialhastigheten for de forskjellige prøvene uttrykt som absorbansøkning pr. min (= hastigheten) ved å plotte absorbansen som funksjon av tiden. Pass på at punktene du skal bruke for kurvetilpassing, fremdeles er i det lineære området. Gjør en lineærtilpasning for å finne initialhastighetene. Lag en figur som presenterer de eksperimentelle dataene og de tilhørende tilpasningene. Lag deretter en visualisering av initialhastigheten som funksjon av substratkonsentrasjonen, som kan angis som mg PNPP (dinatriumsaltet) i 3,5 ml inkubasjonsblanding (mg/3,5 mL). Dette er Michaelis-Menten-plottet. Gjør en kurvetilpasning i Python for å finne $v_{maks}$ og $K_m$. Molekylvekten for dinatriumsaltet av p-nitrofenylfosfat heksahydrat settes lik 371,2 g/mol. Oppgi resultatet for $K_m$ i mol/L. \n",
    "\n",
    "- Forsøk 2: Lag en grafisk fremstilling av reaksjonshastigheten som funksjon av pH. Husk å ta hensyn til fortynning med Tris-buffer.\n",
    "\n",
    "- Forsøk 3: Plott absorbansen som funksjon av tiden for hemmet og uhemmet reaksjon. Finn $K_m$ og $v_{maks}$, og avgjør hva slags hemmer vi har brukt her.\n",
    "\n",
    "Dere skal levere inn en individuell rapport som skal inneholde: \n",
    "\n",
    "1. Introduksjon: En kort innledning for de fire delforsøkene hvor du skriver teori, bakgrunn og hensikten med forsøkene (ca. 1 side, maks 2)\n",
    "2. Metoder: Et kort felles sammendrag av metodene (ca. 1/2 side – for detaljert prosedyre henviser du til laboppgaveteksten).\n",
    "3. Resultater: En resultatdel som skal inneholde tabeller (med tabelltekst over tabellen) og grafer (med figurtekst under) av alle forsøkene.\n",
    "4. Diskusjon: En kort diskusjon/analyse av resultatene (dette vil vanligvis være lengste del av rapporten). \n",
    "5. Utregninger og rådata puttes i appendiks på slutten av rapporten\n",
    "\n",
    "På Canvas ligger det en rapportmal som beskriver hvordan rapporten burde legges opp med lab 2+3 som eksempel og vurderingsmatrise som brukes for vurdering av rapportene. Dere har 2 forsøk på å få godkjent labrapport. Lever inn rapporten (1 per person) for lab 4 i Canvas senest to uker etter labøvelsen er gjennomført.\n",
    "```\n",
    "\n",
    "\n"
   ]
  }
 ],
 "metadata": {
  "celltoolbar": "Edit Metadata",
  "kernelspec": {
   "display_name": "base",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.9.12"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
